<template>
    <div>
        <div>
            <div class="text-center text-bold">
                Employee System
            </div>
            <table v-if="header === true">
                <thead>
                    <tr>
                        <th>Name</th>
                        <th>Email</th>
                        <th>Password</th>
                        <th></th>
                    </tr>
                </thead>
                <tbody>
                    <tr v-for="(employee, index) in employees" :key="index">
                        <td>{{employee.name}}</td>
                        <td>{{employee.email}}</td>
                        <td>{{employee.password}}</td>
                        <td>
                            <button type="button" @click="edit(employee.id)">Edit</button>
                        </td>
                    </tr>
                </tbody>
            </table>
            <form method="post" v-if="header === false">
                <div class="row">
                    <div class="col-md-2">
                        Name:
                    </div>
                    <div class="col-md-5">
                        <input v-model="newEmployee.name" v-validate="'required|min:5'" name="Name" />

                        <span class="field-validation-error" v-if="errors.has('Name')">
                            {{errors.first('Name')}}
                        </span>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-2">
                        Email:
                    </div>
                    <div class="col-md-5">
                        <input v-model="newEmployee.email" v-validate="'required|email'" name="Email" />

                        <span class="field-validation-error" v-if="errors.has('Email')">
                            {{errors.first('Email')}}
                        </span>
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-2">
                        Password:
                    </div>
                    <div class="col-md-5">
                        <input v-model="newEmployee.password" type="password" v-validate="'required'" name="password" />

                        <span class="field-validation-error" v-if="errors.has('password')">
                            {{errors.first('password')}}
                        </span>
                    </div>
                </div>
                <div>
                    <button class="btn btn-primary" @click.prevent="addNewEmployee()" type="button" v-if="isBusy === false">
                        <fa icon="chevron-up"></fa>
                        Create New Employee
                    </button>

                    <button type="button" v-else disabled>
                        <fa icon="spinner" class="fa-spin"></fa>
                        Create New Employee
                    </button>
                </div>
                <div>
                    <a href="/error" class="btn btn-danger">test</a>
                </div>
            </form>
        </div>
    </div>
</template>

<script lang="ts">
    import Vue from 'vue';
    import Component from 'vue-class-component';
    import { userServiceSingleton, UserService } from '../services/UserService';
    import { IEmployeeModel } from '../models/IEmployeeModel';

    @Component({
        created: async function (this: CreateNewEmployee) {
            await this.initialize();
        }
    })
    export default class CreateNewEmployee extends Vue {
        userServiceState = userServiceSingleton;
        newEmployee: IEmployeeModel = {};
        isBusy: boolean = false;
        header: boolean = true;

        async initialize() {
                await this.userServiceState.getUsers();
        }

        get employees() {
            return this.userServiceState.employees;
        }

        async validate() {
            let valid = await this.$validator.validateScopes();

            if (!valid) {
                return false;
            }
            await this.$validator.reset();
            return true;
        }

        async addNewEmployee() {
            this.isBusy = true;

            if (await this.validate() === false) {
                this.isBusy = false;
                return;
            }

            await this.userServiceState.insertUser(this.newEmployee);

            this.newEmployee = {};
            window.location.href = './privacy';
        }

        async edit(id: number) {
            console.log(id);
            await this.userServiceState.getSpecificUser(id);
            this.newEmployee = this.userServiceState.employee;
            this.header = false;
        }
    }
</script>
